<?php
	echo("Cell Color Example\n");
	echo("Set cell size and background color!\n");

	// Load an image to get the colors we should assign to cells
	$pImage = imagecreatefrompng("Duck.png");
	$nWidth = imagesx($pImage);
	$nHeight = imagesy($pImage);

	// Now we construct the workbook, and grab the default worksheet. Ready to start messing with cells
	$pWorkbook = new Workbook("");
	$pWorksheet = $pWorkbook->GetWorksheetByIndex(0);


	// Now that we have our image and our worksheet we'll setup a nice square grid
	// Here we are setting the cell size to 10px by 10px.
	for ($nX = 0; $nX < $nWidth; $nX++)
		$pWorksheet->SetColumnWidth($nX, 7);

	for ($nY = 0; $nY < $nHeight; $nY++)
		$pWorksheet->SetRowHeight($nY, 7);

	for ($nY = 0; $nY < $nHeight; $nY++)
	{
		for ($nX = 0; $nX < $nWidth; $nX++)
		{
			// Pull the color from the image
			$nColor = imagecolorat($pImage, $nX, $nY);

			// Do some bit shifting fun to get the individual color channels out
			$nRed = ($nColor >> 16) & 0xFF;
			$nGreen = ($nColor >> 8) & 0xFF;
			$nBlue = $nColor & 0xFF;
			$nTransparency = ($nColor >> 24) & 0xFF;

			// skip transparent pixels
			if ($nTransparency == 0)
			{
				$pColor = new Color($nRed, $nGreen, $nBlue);

				$pStyle = NULL;
				// reuse the same style if it has the same background color
				for ($i = 0; $i < $pWorkbook->GetNumStyle(); $i++)
				{
					$pTestStyle = $pWorkbook->GetStyleByIndex($i);
					if ($pTestStyle->GetBackgroundColor() && $pTestStyle->GetBackgroundColor()->Equals($pColor))
					{
						$pStyle = $pTestStyle;
						break;
					}
				}

				// reusable style not found, create a new one
				if ($pStyle == NULL)
				{
					$pStyle = $pWorkbook->CreateStyle();
					$pStyle->SetBackgroundColor($pColor);
				}

				// set the cell style (color)
				$pCell = $pWorksheet->GetCell($nX, $nY);
				$pCell->SetStyle($pStyle);
			}
		}
	}

	$pWorkbook->Save("CellColorExample.xls");


?>